<?php
/*
Plugin Name: wpTimeMachine
Plugin URI: http://wordpress.org/extend/plugins/wp-time-machine/
Description: Creates an archive of all your WordPress Data & Files and then emails them along restoration instructions.
Version: 1.0.1
Author: Paul G Petty
Author URI: http://paulgriffinpetty.com/
*/

require 'includes/DropboxUploader.php';
                    
if (!class_exists("wpTimeMachine")) {

	class wpTimeMachine {
		
		function wpTimeMachine() { //constructor
		}
		
		function init() {
		
            $wpTimeMachineVersion = "1.0.4";
            
            $wp_version = get_bloginfo( 'version' );
            
            $wp_installer_url = "http://wordpress.org/wordpress-".$wp_version.".tar.gz";
		
            $wpTimeMachineOptionsStorage = $this->getAdminOptions();

            if (isset($_GET['show_info'])) {
            
                $wpTimeMachineOptionsStorage['show_info'] = $_GET['show_info'];
                
            } 

            if (isset($_POST['remote_user'])) {
            
                $wpTimeMachineOptionsStorage['remote_user'] = $_POST['remote_user'];
                
            } 
              
            if (isset($_GET['remote_pass_storage'])) {
            
                $wpTimeMachineOptionsStorage['remote_pass_storage'] = $_GET['remote_pass_storage'];

              
                if ($_GET['remote_pass_storage'] == "false") {
                
                    $wpTimeMachineOptionsStorage['remote_pass'] = "";
    
                } 
            } 
            
            if (isset($_POST['remote_pass'])) {
            
                if ($wpTimeMachineOptionsStorage['remote_pass_storage'] == "true") {
                    $wpTimeMachineOptionsStorage['remote_pass'] = $_POST['remote_pass'];
                }
                
            } 
                
            update_option($this->adminOptionsName, $wpTimeMachineOptionsStorage);
                        
            $ROOT = $_SERVER['DOCUMENT_ROOT'];                
            
            $wpcontent_dir   = ( defined('WP_CONTENT_DIR') ) ? WP_CONTENT_DIR : ABSPATH . 'wp-content';
            $wpcontent_url   = ( defined('WP_CONTENT_URL') ) ? WP_CONTENT_URL : get_option('siteurl') . '/wp-content';
            
            $wpplugin_dir    = ( defined('WP_PLUGIN_DIR') ) ? WP_PLUGIN_DIR : $wpcontent_dir . '/plugins';
            
            $wpcontent_targz = $wpcontent_dir . "/wpTimeMachine-content-files.tar.gz";
            $wpdata_targz    = $wpcontent_dir . "/wpTimeMachine-data-files.tar.gz";
            $htaccess_targz  = $wpcontent_dir . "/wpTimeMachine-htaccess.tar.gz";   
            $instructions    = $wpcontent_dir . "/wpTimeMachine-Instructions.txt";

            $files = array(
                $wpcontent_targz ,
                $wpdata_targz    ,
                $htaccess_targz  ,
                $instructions
            );
            
            $cron_settings   = "0 0 * * * php " . $wpplugin_dir . "/wp-time-machine/wp-time-machine.php";
  
            // begin plugin UI ...
    		?>
    		
    		<script type="text/javascript" src="http://www.google.com/jsapi"></script>
    		<script type="text/javascript">
    		if (!jQuery) google.load( "jquery","1.3.2" );
    		</script>
    		<script type="text/javascript">
    		
    		function wpTimeMachine_toggle( key, negative, positive ) {

                if ( jQuery("#"+key).attr("value") == "false" ) {
                    var val = true;
                    jQuery("#"+key).text( negative );                    
                } else {
                    var val = false;
                    jQuery("#"+key).text( positive );
                }
                
                jQuery("#"+key).attr("value", val);
                
                if (key == "show_info") {
                    jQuery("#Info").toggle();
                }
                    
                jQuery.ajax({ 
                    data:    "page=wp-time-machine.php&"+key+"="+val,
                    url:     "options-general.php",
                    success: function () {
                        return false;
                    }
                });
    		
    		}

    		jQuery(document).ready( function(){

            	jQuery("#show_info").click( function (event) {
                    event.preventDefault();
                    wpTimeMachine_toggle( "show_info", "Remove all that info above?", "Display all that info that appeared above?" );
            	});
            	
            	jQuery("#remote_pass_storage").click( function (event) {
                    event.preventDefault();
                    wpTimeMachine_toggle( "remote_pass_storage", "Don't save my password.", "Save my password." );
            	});
            
            });
                		
    		</script>
    		
    		<style type="text/css">
        		#wpTimeMachine p { margin:10px 0; padding:5px 0; }
        		#wpTimeMachine div#Info { width:600px; margin:0; padding:0 10px; border-left:2px solid #ccc; }
        		#wpTimeMachine code { border-left:2px solid #ccc; margin:10px 20px; padding:0 5px; display: block; }
        		#wpTimeMachine ol { margin-left: 20px; }
        		#wpTimeMachine em { font-size: 11px; }
        		#wpTimeMachine label { width:250px; display: inline-block; text-align:right; }
        		#wpTimeMachine input { width:300px; }
        		#wpTimeMachine input.cb { width:auto; }
        		#wpTimeMachine .hint { margin:5px 0; padding:5px; border: 1px solid green; background-color:pink; width: auto; }
    		</style>

            <div class="wrap" id="wpTimeMachine">

                <h2>wp Time Machine, version: <? echo $wpTimeMachineVersion; ?></h2>

            <?
            
            if ($wpTimeMachineOptionsStorage['show_info'] != "true") {
            
                ?>
                <div id="Info" style="display:none">
                <?
            
            } else {
            
                ?>
                <div id="Info">
                <?
            
            }
            
            ?>
                
                    <p>
    
                        This plugin is pretty simple.  For now Remote User ID & Password are limited to 
                        <a href="http://dropbox.com" target="_new">Dropbox</a> ... which is really not 
                        a bad thing, at all.  Though, eventually I hope to have other remote options 
                        including Amazon S3 & old fashioned FTP (and SFTP) available as options.
                        
                    </p>
    
                    <p>
    
                        That said there are three important requirements for enjoying this plugin:<br />
                        PHP 5 is required ... this will remain a requirement.<br />
                        The system() function must be enabled; hopefully this can be avoided in the near future. <br />
                        Patience, based on bandwidth and server performance, as well as the performance of the this code itself;
                        it may take a minute or two for the backup process to complete.  It also depends on how much you've
                        written & how many photos (and other files) you've uploaded. 
                        
                    </p>
    
                    <p>
    
                        If this directory: <code><? echo $wpcontent_dir; ?></code> is
                        writable; once you click the button below, these 5 files will appear there:
                        
                        <ol>
                            <li>wpTimeMachine-content-files.tar.gz</li>
                            <li>wpTimeMachine-data-files.tar.gz</li>
                            <li>wpTimeMachine-htaccess.tar.gz <em>[1]</em></li>
                            <li>wpTimeMachine-Instructions.txt <em>[2]</em></li>
                        </ol>
                        
                        <em>
                        [1] if you're not using .htaccess then no, it won't be created <br />
                        [2] if you're ever recovering from a catastrophic WordPress failure, this file will help<br />
                        </em>
                        
                        <div class="hint">
                        It's a good idea to store the following two items on your own, (in the same place as the files above).<br/>
                        Your copy of WordPress: <a href="<? echo $wp_installer_url;?>"><? echo $wp_installer_url;?></a><br/>
                        Your copy of wp-config.php <em>For security purposes this file is not backed up!</em>
                        </div>
    
                    </p>
    
                    <p>
                    
                        After the files are created; they'll be uploaded to <i>your</i> Dropbox & deleted.
    
                    </p>
    
                    <p>
                    
                        Additionally, if available, you can add this to your website's crontab to automate 
                        this process daily:<br /><code><? echo $cron_settings; ?></code><br />
                        
                        <em>
                        Your User ID will get saved; as mentioned below your password will not, unless you 
                        check the box above.  You will have to save your password for the cron job requests to get 
                        processed (though if possible that will change).
                        </em>
    
                    </p>
                    
                </div>

                <p>
          
                    <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>&generate=1&time=<? echo time(); ?>">

                      <fieldset>
                      
                    
                        <label for="remote_user">Remote User ID: </label> 
                        
                            <input type="text" name="remote_user" value="<? echo $wpTimeMachineOptionsStorage['remote_user']; ?>" /> <br />
                     
                    
                        <label for="remote_pass">Remote Password: </label> 
                        
                            <input type="password" id="remote_pass" name="remote_pass" value="<? echo $wpTimeMachineOptionsStorage['remote_pass']; ?>" /> 
                            
                            <? 
                            
                            if ($wpTimeMachineOptionsStorage['remote_pass_storage'] == "true") {
                            
                                ?>
                                <a href="javascript:void(0)" id="remote_pass_storage" value="true">
                                    Don't save my password.
                                </a>
                                <?
                            
                            } else { 
                            
                                ?>
                                <a href="javascript:void(0)" id="remote_pass_storage" value="false">
                                    Save my password.
                                </a>
                                <?
                            
                            }
                            
                            ?>
                            
                            <br />
                                                        
                    
                        <label for="show_info">Show Instructional Information: </label> 
                            
                            <? 
                            
                            if ($wpTimeMachineOptionsStorage['show_info'] == "true") {
                            
                                ?>
                                <a href="javascript:void(0)" id="show_info" value="true">
                                    Remove all that info above?
                                </a>
                                <?
                            
                            } else { 
                            
                                ?>
                                <a href="javascript:void(0)" id="show_info" value="false">
                                    Display all that info that appeared above?
                                </a>
                                <?
                            
                            }
                            
                            ?>
                            
                            <br />
                        
                        <div class="submit">
                            <input type="submit" id="submit_package_request" value="Manually Generate & Email a Time Machine Package" />
                        </div>
                        
                      </fieldset>
                    </form>

                </p>

                <pre id="output" style="display:none">

                <?
                
                if ($_GET['generate'] == 1) {
                
                  // generate instructions text file
                  
                    // these instructions get generated by the plugin so that they can be easily updated &
                    // included with the backup delivery ...
                  
                    $intructions_txt = "
                    _____________________________________________________________________________
                    
                    
                        wpTimeMachine, version: ".$wpTimeMachineVersion."
                    
                    _____________________________________________________________________________
                    
                        These steps are recommendations, if you have a better way to 
                        handle restoration, consider sharing that in the forums, here:
                        
                        http://wordpress.org/tags/wp-time-machine?forum_id=10
                        
                        If you get stuck that's also a good place to search for help
                    
                    _____________________________________________________________________________
                    
                        Step 1)
                        
                            Get your old version of WordPress in place:
                            
                            ".$wp_installer_url."
                            
                            Uncompress that file after downloading it & then upload
                            it to the 'old' location where you had WordPress before.
                            
                            Just like when you first set up WordPress, you will need
                            to make a copy of wp-config-sample.php called wp-config.php
                            and update that file with your database information.  Unless
                            you manually backed this up -- which would've been a good 
                            idea.
                        
                        Step 2)
                        
                            If you had a .htaccess file in use, uncompress this file:
                            
                            wpTimeMachine-htaccess.tar.gz
                            
                            And then place it here:
                            
                            http://yourdomain.com/.htaccess
                            
                        Step 3)
                        
                            Rename the WordPress folder called wp-content to something
                            like wp-content-blank-slate.
                            
                            Uncompress wpTimeMachine-content-files.tar.gz & double check 
                            the directory structure, which should look like:
                            
                            wp-content/
                                        plugins/
                                        themes/
                                        uploads/
                                        
                            (There may be other files in there, too.)
                            
                            Upload wp-content into your WordPress folder from Step 1 ...
                            wp-content should be at the same directory level as 
                            wp-content-blank-slate
                            
                        Step 4)
                        
                            Uncompress wpTimeMachine-data-files.tar.gz ...
                            
                            This will create a .sql file which can be used to restore all
                            of your data.
                            
                            Use the same method you originally used to set up your database
                            to get your back up in place.  This most likely involved using
                            your hosting providers instance of phpMyAdmin. 
                        
                    
                    _____________________________________________________________________________
                    
                        That's it ... start testing ... 
                        
                        wpTimeMachine, version: ".$wpTimeMachineVersion."

                    _____________________________________________________________________________
                    

                    ";
                    
                    $instructions_handle = fopen($instructions, 'w');
                    fwrite($instructions_handle, $intructions_txt);
                    fclose($instructions_handle);
                  
                  // create tar files from wp-content & for htaccess
                
                    system("tar cvfz " . $wpcontent_targz . " " . $wpcontent_dir);
                    system("tar cvfz " . $htaccess_targz . " " . $ROOT . "/.htaccess");
                    
                  // create mysql dump, also a tar.gz
                  
                    system("mysqldump --opt -h " . DB_HOST . " -u " . DB_USER . " -p" \
                                    . DB_PASSWORD . " " . DB_NAME . " | gzip > " . $wpdata_targz);

                  // start processing the files
                
                    // this currently only considers Dropbox -- eventually a preference will drive
                    // the possibility of other destinations ...
                
                    $uploader = new DropboxUploader($_POST['remote_user'], $_POST['remote_pass']);

                    foreach ($files as $i => $file) {
                        
                        // upload the file
                        $uploader->upload( $file );
                        
                        // now delete it ... maybe at some point this will be optional; but would
                        // require storing archives outside of WP, otherwise archives grow exponentially :)
                        unlink( $file );

                    }

                }
                    
                ?>

                </pre><!-- close #output -->

            </div>
    		<?php
    		// End plugin ui
    		
    		
    	} // End function init()
    	
        function  getAdminOptions() {
        
            $wpTimeMachineOptions = array(
                'show_info' => 'true',
                'remote_user' => 'true',
                'remote_pass_stored' => 'false',
                'remote_pass' => ''
            );
                
            $wpTimeMachineOptionsStorage = get_option($this->adminOptionsName);
            
            if (!empty($wpTimeMachineOptionsStorage)) {
            
                foreach ($wpTimeMachineOptionsStorage as $key => $option) {
                    
                         $wpTimeMachineOptions[$key] = $option;
                         
                }
                    
            }  
                      
            update_option($this->adminOptionsName, $wpTimeMachineOptions);
            
            return $wpTimeMachineOptions;
            
        } // End function getAdminOptions()
 
        /*
        function writeAdminScripts() {
        
            wp_enqueue_script('jquery');
            wp_enqueue_script('jquery-form');
            wp_enqueue_script('wp-time-machine.js','wp-time-machine.js');

        }
        */
        
	}

} // End Class wpTimeMachine

if (class_exists("wpTimeMachine")) {
	$wpTimeMachine = new wpTimeMachine();
}

// Initialize the admin panel
if (!function_exists("wpTimeMachine_ap")) {
	function wpTimeMachine_ap() {
        global $wpTimeMachine;
        if (!isset($wpTimeMachine)) {
            return;
        }
        if (function_exists('add_options_page')) {
            add_options_page('wp Time Machine', 'wp Time Machine', 9, basename(__FILE__), array(&$wpTimeMachine, 'init'));
        }
	}	
}

// WP Actions
if (isset($wpTimeMachine)) {
  
    /*
    add_action('admin_print_scripts-options.php', 'writeAdminScripts' ); 
    */
	add_action('admin_menu', 'wpTimeMachine_ap');
    add_action('wp-time-machine/wp-time-machine.php',  array(&$wpTimeMachine, 'init'));
	
}

?>